    .model small,c
    .386
    .stack

    include support.asm

    PARTENTRY struct
      peBootable          db ?
      peBeginHead         db ?
      peBeginSector       db ?
      peBeginCylinder     db ?
      peFileSystem        db ?
      peEndHead           db ?
      peEndSector         db ?
      peEndCylinder       db ?
      peStartSector       dd ?
      peSectors           dd ?
    PARTENTRY ends

    BOOTSECTOR struct
      bsJump              db 3 dup(?)
      bsOemName           db 8 dup(?)
      ; start of BPB
      bsBytesPerSector    dw ?
      bsSectorsPerCluster db ?
      bsReservedSectors   dw ?
      bsFats              db ?
      bsRootDirEntries    dw ?
      bsSectors           dw ?
      bsMedia             db ?
      bsFatSectors        dw ?
      bsSectorsPerTrack   dw ?
      bsHeads             dw ?
      bsHiddenSectors     dd ?
      bsHugeSectors       dd ?
      ; end of BPB
      bsDriveNumber       db ?
      bsReserved          db ?
      bsBootSignature     db ?
      bsVolumeId          dd ?
      bsVolumeLabel       db 11 dup(?)
      bsFileSystemType    db 8 dup(?)
      filler              db 384 dup(?)
      pe1                 PARTENTRY <>
      pe2                 PARTENTRY <>
      pe3                 PARTENTRY <>
      pe4                 PARTENTRY <>
      signature           dw ?
    BOOTSECTOR ends

.data?
    buffer BOOTSECTOR <>
.code

ReadSector proc c drive:BYTE,
                  cyl:WORD,
                  head:BYTE,
                  sector:BYTE
    mov ah, 2
    mov al, 1
    mov cx, cyl
    xchg ch, cl
    shl cl, 6
    or  cl, sector
    mov dh, head
    mov dl, drive
    push ds
    pop es
    mov bx, OFFSET buffer
    int 13h
    ret
ReadSector endp

.startup
    ;print word$(SIZEOF BOOTSECTOR)
    invoke ReadSector,80h,0,0,1
    jnc @F
    print "ReadSector error"
  @@:
    .IF buffer.signature == 0aa55h
      .IF buffer.pe1.peBootable == 80h
        print "peBeginCylinder=",byte$(buffer.pe1.peBeginCylinder),NL
        print "peBeginHead=",byte$(buffer.pe1.peBeginHead),NL
        print "peBeginSector=",byte$(buffer.pe1.peBeginSector),NL
        invoke ReadSector, 80h,
                           buffer.pe1.peBeginCylinder,
                           buffer.pe1.peBeginHead,
                           buffer.pe1.peBeginSector
        jnc @F
        print "ReadSector error"
      @@:
        print "Press any key to continue...",NL
        call waitkey
        invoke dumpmem,ds,ADDR buffer,16
        print "Press any key to continue...",NL
        call waitkey
        invoke dumpmem,ds,ADDR buffer+256,16
      .ENDIF
    .ENDIF
    ;print hexword$(buffer.signature),NL
    call waitkey
.exit
end

